﻿using System;
using System.Drawing;

namespace CBNA_Defender
{
    public class Particule
    {
        public bool Flare;
        public PointF Position;
        public PointF Vitesse;
        public PointF Gravity;
        public Image Sprite;
        public float AnimSpeed;
        public Int16 AnimEnd;
        public int LifeTime;
        public Point Size;
        public Rectangle AnimMask;
        public float Anim = 0;
        public int Type;
        public Particule()
        {

        }
        public static void Update()
        {
            for(int i=0;i<Ressources.ListParticule.Count;i++)
                if (Ressources.ListParticule[i].LifeTime > 0)
                {
                    Ressources.ListParticule[i].Position.X += Ressources.ListParticule[i].Vitesse.X;
                    Ressources.ListParticule[i].Position.Y += Ressources.ListParticule[i].Vitesse.Y;
                    Ressources.ListParticule[i].Vitesse.X += Ressources.ListParticule[i].Gravity.X;
                    Ressources.ListParticule[i].Vitesse.Y += Ressources.ListParticule[i].Gravity.Y;
                    Ressources.ListParticule[i].AnimMask = new Rectangle((int)Ressources.ListParticule[i].Anim * (int)Ressources.ListParticule[i].Size.X, 0, (int)Ressources.ListParticule[i].Size.X, (int)Ressources.ListParticule[i].Size.Y);
                    Ressources.ListParticule[i].Anim += Ressources.ListParticule[i].AnimSpeed;
                    if (Ressources.ListParticule[i].Anim > Ressources.ListParticule[i].AnimEnd)
                        Ressources.ListParticule[i].Anim = 0;
                    Ressources.ListParticule[i].LifeTime--;
                    if (Ressources.ListParticule[i].LifeTime == 0)
                        switch (Ressources.ListParticule[i].Type)
                        {
                            case 0:
                                {
                                    Form1.PartCreate(false, Ressources.ListParticule[i].Position, new PointF(0, 0), new PointF(0, 0), Ressources.SprParticules[1], 0.3f, 4, 16, new Point(84, 77), 1);
                                    for (byte j = 0; j < 10; j++)
                                        Form1.PartCreate(true, Ressources.ListParticule[j].Position, new PointF(-5.0f + Ressources.Random.Next(100) / 10.0f, -5.0f + Ressources.Random.Next(100) / 10.0f), new PointF(0, 0.1f), Ressources.SprParticules[2], 0, 1, 70, new Point(5, 5), 2);
                                    break;
                                }
                            case 2:
                                {
                                    for (byte j = 0; j < 10; j++)
                                        Form1.PartCreate(false, Ressources.ListParticule[j].Position, new PointF(-2.0f + Ressources.Random.Next(40) / 10.0f, -0.1f), new PointF(0, -0.1f), Ressources.SprParticules[4], 0.2f, 4, 25, new Point(10, 10), 4);
                                    break;
                                }
                        }
                    if (Ressources.ListParticule[i].Flare)
                        switch (Ressources.ListParticule[i].Type)
                        {
                            case 2:
                                {
                                    Form1.PartCreate(false, Ressources.ListParticule[i].Position, new PointF(0, 0), new PointF(0, 0), Ressources.SprParticules[3], 0, 1, 10, new Point(5, 5), 3);
                                    Form1.PartCreate(false, Ressources.ListParticule[i].Position, new PointF(-2.0f + Ressources.Random.Next(40) / 10.0f, -0.1f), new PointF(0, -0.1f), Ressources.SprParticules[4], 0.2f, 4, 25, new Point(10, 10), 4);
                                    break;
                                }
                        }
                }
        }
    }
}