﻿using System;
using System.Drawing;

namespace CBNA_Defender
{
    public class Tower
    {
        public Rectangle Border;//bordure à enlever(gauche,haut,hauteur,largeur)
        public float Anim = 0, AnimSpeed;
        public Int16 AnimEnd;
        public Int16 AnimDeadEnd;
        public Point Size;
        public bool Alive = true;
        public PointF Position;
        public Image Sprite;
        public int Type;
        public bool Effects;
        public Rectangle Mask;
        public Rectangle MaskAnim;
        public float Tirer = 0;
        public string Nom;
        public Int16 Degat;
        public Int16 ArmeLvL = 0;
        public Int16 ArmePriceBase;
        public Int16 ArmePriceModifier;
        public Int16[] PriceBase = new Int16[6];
        public Int16[] PriceModifier = new Int16[6];
        public Int16[] Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
        public float[] Stats = new float[6];
        public float[] StatsModifier = new float[6];
        //Armure, Cadence, Energie, Puissance, Resistance, Special;
        public Tower()
        {

        }
        public static void Update()
        {
            for (int i = 0; i < Ressources.ListTower.Count; i++)
                if (Ressources.ListTower[i].Alive)
                {
                    Ressources.ListTower[i].MaskAnim = new Rectangle((int)Ressources.ListTower[i].Anim * (int)Ressources.ListTower[i].Size.X, 0, (int)Ressources.ListTower[i].Size.X, (int)Ressources.ListTower[i].Size.Y);
                    Ressources.ListTower[i].Anim += Ressources.ListTower[i].AnimSpeed;
                    if (Ressources.ListTower[i].Stats[0] > 0)
                    {
                        if (Ressources.ListTower[i].Anim > Ressources.ListTower[i].AnimEnd)
                            Ressources.ListTower[i].Anim = 0;
                    }
                    else
                        if (Ressources.ListTower[i].Anim > Ressources.ListTower[i].AnimDeadEnd)
                            Ressources.ListTower[i].Dead();
                    if (Ressources.ListTower[i].Tirer > 0)
                        Ressources.ListTower[i].Tirer--;
                    else if (Form1.Energie > Ressources.ListTower[i].Stats[2])
                    {
                        switch (Ressources.ListTower[i].Type)
                        {
                            case 0:
                                {
                                    if (!Ressources.ListTower[i].Effects)
                                        Form1.BalleCreate(Ressources.SprBullet[0], new PointF(Ressources.ListTower[i].Position.X + 2, Ressources.ListTower[i].Position.Y + 12), new PointF(-3, 0), Ressources.ListTower[i].Stats[3], Ressources.ListTower[i].Stats[4], 0);
                                    else
                                        Form1.BalleCreate(Ressources.SprBullet[0], new PointF(Ressources.ListTower[i].Position.X + 24, Ressources.ListTower[i].Position.Y + 12), new PointF(3, 0), Ressources.ListTower[i].Stats[3], Ressources.ListTower[i].Stats[4], 0);
                                    break;
                                }
                            case 1:
                                {
                                    if (!Ressources.ListTower[i].Effects)
                                        Form1.BalleCreate(Ressources.SprBullet[1], new PointF(Ressources.ListTower[i].Position.X, Ressources.ListTower[i].Position.Y + 12), new PointF(-3, 0), Ressources.ListTower[i].Stats[3], Ressources.ListTower[i].Stats[4], 1);
                                    else
                                        Form1.BalleCreate(Ressources.SprBullet[1], new PointF(Ressources.ListTower[i].Position.X + 30, Ressources.ListTower[i].Position.Y + 12), new PointF(3, 0), Ressources.ListTower[i].Stats[3], Ressources.ListTower[i].Stats[4], 1);
                                    break;
                                }
                            case 2:
                                {
                                    if (Form1.Energie + Ressources.ListTower[i].Stats[2] * (Ressources.ListMonstre.Count / 5) < Form1.MaxEnergie)
                                        Form1.Energie -= Ressources.ListTower[i].Stats[2] * (Ressources.ListMonstre.Count / 5);
                                    else
                                        Form1.Energie = Form1.MaxEnergie;
                                    break;
                                }
                        }
                        Form1.Energie -= Ressources.ListTower[i].Stats[2];
                        Ressources.ListTower[i].Tirer = Ressources.ListTower[i].Stats[1];
                    }
                }
        }
        public void Dead()//Mort
        {
            Alive = false;
            switch (Type)
            {
                case 0:
                    {
                        Form1.Argent += 10;
                        break;
                    }
                case 1:
                    {
                        foreach (Tower Tower in Ressources.ListTower)
                            if (Position.Y - 30 == Tower.Position.Y && Position.X == Tower.Position.X)
                                foreach (Tower Spec in Ressources.ListTower)
                                    if (Position == Spec.Position && Spec.Type != 3)
                                        Tower.Dead();
                        Form1.Argent += 6;
                        break;
                    }
                case 2:
                    {
                        Form1.Argent += 3;
                        break;
                    }
                case 3:
                    {
                        foreach (Tower Tower in Ressources.ListTower)
                            if (Position.Y - 30 == Tower.Position.Y && Position.X == Tower.Position.X)
                                if (Tower.Type == 1)
                                {
                                    foreach (Tower Spec in Ressources.ListTower)
                                        if (Position == Spec.Position && Spec.Type != 1)
                                            Tower.Dead();
                                }
                                else
                                    Tower.Dead();
                        Form1.Argent += 6;
                        break;
                    }
            }


        }
    }
}