﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
/*Briand Brousseau Demers
*Tower defense vu de coté
*Défendre l'arbre
*acheter à souhait
*/
namespace CBNA_Defender
{
    public partial class Form1 : Form
    {
        FileInfo File = new FileInfo("File");
        Brush TextAqua = new SolidBrush(Color.Aqua);
        Brush TextForestGreen = new SolidBrush(Color.ForestGreen);
        Brush TextSienna = new SolidBrush(Color.Sienna);
        Brush TextBlack = new SolidBrush(Color.Black);
        BufferedGraphicsContext GraphicContext;
        BufferedGraphics GraphicDevice;
        #region Déclaration de variables
        public static Int16 Vie = 100, MaxEnergie = 200;
        public static int Argent = 1000, Exp = 0;
        public static bool Fermer = false;
        Int16 MaxVie = 100, MaxExp = 1000, Niveau = 0;
        public static float Energie = 200;
        Int16 Selectector = 0;//hauteur du selecteur
        Int16 SelectHelp = 0;
        int Select = 0;//tour sélectioné
        Int16 Group = 0;//groupe d'objet sélectionné
        byte[] GroupSize = new byte[4] { 2, 0, 2, 0 };
        public static byte Wave = 0;
        public static int[] Timer = new int[3];
        public static int[] TimerBase;
        public static int[] MonsterSpawn = new int[3];
        public static int[] MonstreLife = new int[3];
        bool NextWave = false;
        bool CanPlace = true;//Si on peux placer une tour
        bool IsSelected = false;//Si un tour est en cours de placement
        bool Pause = false;
        bool Upgrading = false, IsUpgrade = true, IsUpgradeHelp = false;
        Int16 UpgradeSelect = 0;
        PointF UpgradeMenu;
        Rectangle TowerPlace = new Rectangle(392, 690, 30, 30);
        Tower TowerSelected = null;
        bool Effects;
        Font Kootenay = new Font(FontFamily.GenericSansSerif, 12);
        Image SprCBNA;
        Image SprSol;
        Image[] SprSelector = new Image[3];
        Image SprHelpMenu;
        Image SprTowerSelect, SprTowerSelector;
        Image SprUpgradeMenu;
        Image SprUpgradeButtonUp, SprUpgradeButtonDown;
        Image SprUpgradeHelpUp, SprUpgradeHelpDown, SprUpgradeHelpMenu;
        Image[] SprPowerBar = new Image[4];
        Image[,] SprShopPreview = new Image[4, 2];
        Image[] SprNuage = new Image[4];
        Nuage[] ListNuage = new Nuage[20];
        Random Random = new Random();
        #endregion
        Keys KeyPressed;
        public Form1()
        {
            //msie en plein écran réel
            this.Left = (Screen.PrimaryScreen.Bounds.Width / 2 - this.Width / 2);
            this.Top = (Screen.PrimaryScreen.Bounds.Height / 2 - this.Height / 2);
            for (Int16 i = 0; i < 20; i++)
            {
                ListNuage[i] = new Nuage();
                ListNuage[i].Position = new PointF(Random.Next(1024), i * 23);
                ListNuage[i].Vitesse = new PointF(-1 - Random.Next(7), 0);
                ListNuage[i].Sprite = Random.Next(4);
            }
            InitializeComponent();
            LoadContent();
            WaveSelect();
            //allocation du buffer
            GraphicContext = BufferedGraphicsManager.Current;
            GraphicContext.MaximumBuffer = new Size(this.Width + 1, this.Height + 1);
            GraphicDevice = GraphicContext.Allocate(this.CreateGraphics(), new Rectangle(0, 0, this.Width, this.Height + 24));
        }

        void LoadContent()
        {
            SprCBNA = Image.FromFile("Content\\Logo_CBNA.png");
            SprSol = Image.FromFile("Content\\sol.png");
            SprSelector[0] = Image.FromFile("Content\\Selector.png");
            SprSelector[1] = Image.FromFile("Content\\SelectorRed.png");
            SprSelector[2] = Image.FromFile("Content\\SelectorGreen.png");
            SprHelpMenu = Image.FromFile("Content\\ShopDetails.png");
            SprTowerSelect = Image.FromFile("Content\\Tower Select.png");
            SprTowerSelector = Image.FromFile("Content\\TowerSelector.png");
            SprUpgradeMenu = Image.FromFile("Content\\UpgradeMenu.png");
            SprUpgradeButtonUp = Image.FromFile("Content\\UpgradeButtonUp.png");
            SprUpgradeButtonDown = Image.FromFile("Content\\UpgradeButtonDown.png");
            SprUpgradeHelpUp = Image.FromFile("Content\\UpgradeHelpUp.png");
            SprUpgradeHelpDown = Image.FromFile("Content\\UpgradeHelpDown.png");
            SprUpgradeHelpMenu = Image.FromFile("Content\\UpgradeHelpMenu.png");
            SprPowerBar[0] = Image.FromFile("Content\\PowerBarVide.png");
            SprPowerBar[1] = Image.FromFile("Content\\PowerBarVie.png");
            SprPowerBar[2] = Image.FromFile("Content\\PowerBarMana.png");
            SprPowerBar[3] = Image.FromFile("Content\\PowerBarExp.png");
            SprNuage[0] = Image.FromFile("Content\\Nuage0.png");
            SprNuage[1] = Image.FromFile("Content\\Nuage1.png");
            SprNuage[2] = Image.FromFile("Content\\Nuage2.png");
            SprNuage[3] = Image.FromFile("Content\\Nuage3.png");
            Ressources.SprTower[0, 0, 0] = Image.FromFile("Content\\Tower0.png");
            Ressources.SprTower[0, 0, 1] = Image.FromFile("Content\\Tower0R.png");
            Ressources.SprTower[0, 1, 0] = Image.FromFile("Content\\Tower1.png");
            Ressources.SprTower[0, 1, 1] = Image.FromFile("Content\\Tower1R.png");
            Ressources.SprTower[2, 0, 0] = Image.FromFile("Content\\Utilitaire0.png");
            Ressources.SprTower[2, 0, 1] = Image.FromFile("Content\\Utilitaire0R.png");
            Ressources.SprTower[2, 1, 0] = Image.FromFile("Content\\Utilitaire1.png");
            Ressources.SprTower[2, 1, 1] = Image.FromFile("Content\\Utilitaire1R.png");
            SprShopPreview[0, 0] = Image.FromFile("Content\\TowerPreview0.png");
            SprShopPreview[0, 1] = Image.FromFile("Content\\TowerPreview1.png");
            SprShopPreview[2, 0] = Image.FromFile("Content\\UtiPreview0.png");
            SprShopPreview[2, 1] = Image.FromFile("Content\\UtiPreview1.png");
            Ressources.SprBullet[0] = Image.FromFile("Content\\Bullet0.png");
            Ressources.SprBullet[1] = Image.FromFile("Content\\Bullet1.png");
            Ressources.SprMonstre[0, 0] = Image.FromFile("Content\\Monstre0.png");
            Ressources.SprMonstre[0, 1] = Image.FromFile("Content\\Monstre0R.png");
            Ressources.SprMonstre[1, 0] = Image.FromFile("Content\\Monstre1.png");
            Ressources.SprMonstre[1, 1] = Image.FromFile("Content\\Monstre1R.png");
            Ressources.SprMonstre[2, 0] = Image.FromFile("Content\\Monstre2.png");
            Ressources.SprMonstre[2, 1] = Image.FromFile("Content\\Monstre2R.png");
            Ressources.SprParticules[0] = Image.FromFile("Content\\Monstre2Dead.png");
            Ressources.SprParticules[1] = Image.FromFile("Content\\Monstre2Explo.png");
            Ressources.SprParticules[2] = Image.FromFile("Content\\Monstre2HatPart.png");
            Ressources.SprParticules[3] = Image.FromFile("Content\\Monstre2HatFlare.png");
            Ressources.SprParticules[4] = Image.FromFile("Content\\Monstre2HatSmoke.png");
        }
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            //Permet d'utiliser des touches dnas le timer
            KeyPressed = keyData;
            return base.ProcessCmdKey(ref msg, keyData);
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            //Quitter, même sur un PC sécurisé
            if (KeyPressed == Keys.Escape)
            {
                timer1.Enabled = false;
                new frmMenu().ShowDialog();
                if (Fermer)
                {
                    this.Close();
                    return;
                }
                else
                    timer1.Enabled = true;
            }
            //Mettre en pause/désactiver la pause
            if (KeyPressed == Keys.Enter)
            {
                Pause = !Pause;
                SelectHelp = 0;
                //remise à 0 des fonction du curseur
                if (IsSelected)
                {
                    IsSelected = false;
                    Selectector = 0;
                    TowerPlace = new Rectangle((int)TowerPlace.X, (int)TowerPlace.Y, 30, 30);
                }
                //fin du menu d'upgrade
                if (Upgrading)
                    Upgrading = false;
            }
            //Si en pause(menu de choix des tours) et pas en upgrade (qui active aussi la pause)
            if (KeyPressed == Keys.Space && Pause && !Upgrading)
                if (!IsSelected)
                {
                    //On active le choix de tour
                    IsSelected = true;
                    Selectector = 0;
                }
                else//sinon donc pas en pause
                    if (CanPlace && CanBuildTower(true))//si on peut la placer et l'acheter
                        //on créé une tour
                        CreateTower();
            if (Upgrading)//Si on upgrade
            {
                if (KeyPressed == Keys.Up)
                {
                    UpgradeSelect--;
                    if (UpgradeSelect < 0)
                        UpgradeSelect = 6;
                }
                if (KeyPressed == Keys.Down)
                {
                    UpgradeSelect++;
                    if (UpgradeSelect > 6)
                        UpgradeSelect = 0;
                }
                if (KeyPressed == Keys.Left || KeyPressed == Keys.Right)
                {
                    IsUpgrade = !IsUpgrade;//colone upgrade ou colone aide
                    IsUpgradeHelp = false;//efface l'aide
                }
                if (KeyPressed == Keys.Space)
                    if (IsUpgrade)//si colone upgrade
                        Upgrade();//achat d'upgrade
                    else//sinon colone aide
                        IsUpgradeHelp = !IsUpgradeHelp;//active/désactive l'aide
            }
            else
                if (Selectector == 0)//si le menu d'achat de tour est pas afficher(hauteur du menu)
                {
                    if (KeyPressed == Keys.Right && TowerPlace.X < 990)
                        TowerPlace.X += 30;
                    if (KeyPressed == Keys.Left && TowerPlace.X > 2)
                        TowerPlace.X -= 30;
                    if (KeyPressed == Keys.Up && TowerPlace.Y > 0)
                        TowerPlace.Y -= 30;
                    if (KeyPressed == Keys.Down && TowerPlace.Y + TowerPlace.Height < 718)
                        TowerPlace.Y += 30;
                }
            #region Achat de tour en cours
            if (IsSelected)//si achat de tour
            {//mask normal
                TowerPlace = new Rectangle((int)TowerPlace.X, (int)TowerPlace.Y, 30, 30);
                if (TowerPlace.X <= 502)//flip l'image si à droite
                    Effects = false;
                else
                    Effects = true;
                switch (Group)
                {
                    case 0://tours au sol
                        {
                            switch (Select)
                            {
                                case 0://Bunker
                                    {
                                        if (Ressources.ListTower.Count != 0)//si ya au moins une tour
                                        {
                                            CanPlace = false;
                                            foreach (Tower Tower in Ressources.ListTower)
                                                if (!TowerPlace.IntersectsWith(Tower.Mask) || !Tower.Alive)
                                                {
                                                    if (TowerPlace.Y == 690 || (TowerPlace.Y + 30 == Tower.Position.Y && TowerPlace.X == Tower.Position.X && Tower.Type == 3))
                                                        CanPlace = true;
                                                }
                                                else
                                                {
                                                    if (Tower.Type == 3)
                                                        CanPlace = true;
                                                    else
                                                    {
                                                        CanPlace = false;
                                                        break;
                                                    }
                                                }
                                        }
                                        else
                                            if (TowerPlace.Y == 690)
                                                CanPlace = true;
                                            else
                                                CanPlace = false;
                                        break;
                                    }
                                case 1:
                                    {
                                        if (Ressources.ListTower.Count != 0)//si ya au moins une tour
                                        {
                                            CanPlace = false;
                                            foreach (Tower Tower in Ressources.ListTower)
                                                if (!TowerPlace.IntersectsWith(Tower.Mask) || !Tower.Alive)
                                                {
                                                    if (TowerPlace.Y == 690 || (TowerPlace.Y + 30 == Tower.Position.Y && TowerPlace.X == Tower.Position.X && (Tower.Type == 1 || Tower.Type == 3)))
                                                        CanPlace = true;
                                                }
                                                else
                                                {
                                                    if (Tower.Type == 3)
                                                        CanPlace = true;
                                                    else
                                                    {
                                                        CanPlace = false;
                                                        break;
                                                    }
                                                }
                                        }
                                        else
                                            if (TowerPlace.Y == 690)
                                                CanPlace = true;
                                            else
                                                CanPlace = false;
                                        break;
                                    }
                            }
                            break;
                        }
                    case 2: //Utilitaire
                        {
                            switch (Select)
                            {
                                case 0://Roue à humain
                                    {
                                        //mask plus gros pour sprite plus gros
                                        TowerPlace = new Rectangle((int)TowerPlace.X, (int)TowerPlace.Y, 60, 60);
                                        if (Ressources.ListTower.Count != 0)//si ya au moins une tour
                                        {
                                            CanPlace = false;
                                            foreach (Tower Tower in Ressources.ListTower)
                                                if (!TowerPlace.IntersectsWith(Tower.Mask) || !Tower.Alive)
                                                {
                                                    if (TowerPlace.Y == 660)
                                                        CanPlace = true;
                                                }
                                                else
                                                {
                                                    CanPlace = false;
                                                    break;
                                                }
                                        }
                                        else
                                            if (TowerPlace.Y == 660)
                                                CanPlace = true;
                                            else
                                                CanPlace = false;
                                        break;
                                    }
                                case 1://échafaud
                                    {
                                        if (Ressources.ListTower.Count != 0)
                                        {
                                            CanPlace = false;
                                            foreach (Tower Tower in Ressources.ListTower)
                                                if (!TowerPlace.IntersectsWith(Tower.Mask) || !Tower.Alive)
                                                {
                                                    if (TowerPlace.Y == 690 || (TowerPlace.Y + 30 == Tower.Position.Y && TowerPlace.X == Tower.Position.X && Tower.Type == 3))
                                                        CanPlace = true;
                                                }
                                                else
                                                {

                                                    if (Tower.Type != 3)
                                                        CanPlace = true;
                                                    else
                                                    {
                                                        CanPlace = false;
                                                        break;
                                                    }
                                                }
                                        }
                                        else
                                            if (TowerPlace.Y == 690)
                                                CanPlace = true;
                                            else
                                                CanPlace = false;
                                        break;
                                    }
                            }
                            break;
                        }
                }
                if (!CanBuildTower(false))//si on peut pas acheter
                    CanPlace = false;//on peut pas placer
            }
            else//menu d'achat ouvert
            {
                if (Selectector > 0)//Choix de tour ouvert
                {
                    if (SelectHelp < 160)//attente avant d'afficher l'aide
                        SelectHelp++;
                    if (KeyPressed == Keys.Right)
                    {
                        SelectHelp = 0;
                        if (Select < GroupSize[Group])//déaplcement dans le menu
                        {
                            Select++;
                            while (Select == GroupSize[Group])//boucle pour se déplacer dnas les groupes de tour
                            {
                                Group++;
                                Select = 0;//premier choix
                                if (Group == 4)//si dépassement de groupe
                                    Group = 0;//retour au premier groupe
                            }
                        }
                    }
                    if (KeyPressed == Keys.Left)
                    {
                        SelectHelp = 0;
                        if (Select > -1)//déaplcement dans le menu
                        {
                            Select--;
                            while (Select == -1)//boucle pour se déplacer dnas les groupes de tour
                            {
                                Group--;
                                if (Group < 0)//premier choix
                                    Group = 3;//si dépassement de groupe
                                Select = GroupSize[Group] - 1;//retour au premier groupe
                            }
                        }

                    }
                }
                else//en train de jouer
                    foreach (Tower Tower in Ressources.ListTower)
                        //si le curseur touche à une tour qui n'Est pas un échafeau (non upgradable)
                        if (TowerPlace.IntersectsWith(Tower.Mask) && KeyPressed == Keys.Space && Tower.Type != 3)
                        {
                            if (!Upgrading)//si pas en mdoe upgrade
                            {
                                Upgrading = true;//on passe en mode upgrade
                                Pause = true;//on met en pause
                                TowerSelected = Tower;//on assigne la tour à tower selected poru al modifier
                                UpgradeMenu = Tower.Position;//on met le coordonné de la tour pour afficher le menu upgrade
                            }
                        }
            }
            #endregion

            // TODO: Add your update logic here
            if (Pause && !Upgrading && !IsSelected)//si le menu est dévoilé
            {
                if (Selectector < 150)
                    Selectector += 3;
            }
            else//si il est caché
                if (Selectector > 0)
                    Selectector -= 3;
            if (!Pause)//si pas en pause
            {
                //on rajoute de l'énergie
                if (Energie < MaxEnergie)
                {
                    Energie += 0.15f;
                    if (Energie > MaxEnergie)
                        Energie = MaxEnergie;
                }
                //vérification de la prochaine vague
                NextWave = true;
                for (Int16 i = 0; i < Timer.Length; i++)
                {
                    if (Timer[i] > 0)
                        Timer[i]--;
                    else
                    {
                        //si il reste un monstre de sa catégorie
                        if (MonsterSpawn[i] > 0)
                        {
                            //on le créé
                            CreateMonstre(i);
                            //remet le timer pour créé le prochain
                            Timer[i] = TimerBase[i];
                            //on enlève un monstre à créé
                            MonsterSpawn[i]--;
                        }
                    }
                    if (MonsterSpawn[i] > 0)//si il reste un monstre
                        NextWave = false;//on passe pas à la prochaine vague
                }
                if (NextWave)//si on peut passer à la prochaine vague
                    WaveSelect();//on change de vague
                //on met tout à jour
                Tower.Update();
                Balle.Update();
                Monstre.Update();
                Particule.Update();
                //monté de niveau
                if (Exp > MaxExp)
                {
                    LevelUp();
                }
            }
            //on affiche
            Draw();
            //on met à jour les nuages
            UpdateNuage();
            //on remet à null la touche pressé car c'est un timer et non un process key
            KeyPressed = Keys.None;
        }
        void Upgrade()
        {
            switch (UpgradeSelect)
            {
                case 0://Arme
                    {
                        if (TowerSelected.ArmeLvL < 3 && Argent >= (TowerSelected.ArmePriceBase + TowerSelected.ArmeLvL * TowerSelected.ArmePriceModifier))
                        {
                            Argent -= (Int16)(TowerSelected.ArmePriceBase + TowerSelected.ArmeLvL * TowerSelected.ArmePriceModifier);
                            TowerSelected.ArmeLvL++;
                        }
                        break;
                    }
                default:
                    {
                        if ((TowerSelected.Niveau[UpgradeSelect - 1] < TowerSelected.ArmeLvL * 3)
                            && Argent >= (TowerSelected.PriceBase[UpgradeSelect - 1] + (TowerSelected.Niveau[UpgradeSelect - 1] / 3 + 1) * TowerSelected.Niveau[UpgradeSelect - 1] * TowerSelected.PriceModifier[UpgradeSelect - 1])
                            && TowerSelected.PriceModifier[UpgradeSelect - 1] >= 0)
                        {
                            Argent -= Convert.ToInt16(TowerSelected.PriceBase[UpgradeSelect - 1] + (TowerSelected.Niveau[UpgradeSelect - 1] / 3 + 1) * TowerSelected.Niveau[UpgradeSelect - 1] * TowerSelected.PriceModifier[UpgradeSelect - 1]);
                            TowerSelected.Stats[UpgradeSelect - 1] += TowerSelected.StatsModifier[UpgradeSelect - 1];
                            TowerSelected.Niveau[UpgradeSelect - 1]++;
                        }
                        break;
                    }
            }
        }
        void UpdateNuage()
        {
            for (Int16 i = 0; i < 20; i++)
                if (ListNuage[i].Position.X > 0 - SprNuage[ListNuage[i].Sprite].Width)
                    ListNuage[i].Position.X += ListNuage[i].Vitesse.X;
                else
                {
                    ListNuage[i].Position.X = 1024;
                    ListNuage[i].Sprite = Random.Next(4);
                    ListNuage[i].Vitesse.X = -1 - Random.Next(7);
                }
        }
        public static void TowerCreate(string Nom, int Type, PointF Position, bool Effects,
    Rectangle Border, float AnimSpeed, Int16 AnimEnd, Int16 AnimDeadEnd,
    Point Size, Image Sprite, Int16 Degat, Int16 ArmePriceBase,
    Int16 ArmePriceModifier, Int16 PriceBase0, Int16 PriceBase1,
    Int16 PriceBase2, Int16 PriceBase3, Int16 PriceBase4, Int16 PriceBase5,
    Int16 PriceModifier0, Int16 PriceModifier1, Int16 PriceModifier2,
    Int16 PriceModifier3, Int16 PriceModifier4, Int16 PriceModifier5,
    float Stats0, float Stats1, float Stats2, float Stats3, float Stats4, float Stats5,
    float StatsModifier0, float StatsModifier1, float StatsModifier2,
        float StatsModifier3, float StatsModifier4, float StatsModifier5)
        {
            for (int i = 0; i < Ressources.ListTower.Count; i++)
                if (!Ressources.ListTower[i].Alive)
                {
                    Ressources.ListTower[i].Anim = 0;
                    Ressources.ListTower[i].Tirer = 0;
                    Ressources.ListTower[i].ArmeLvL = 0;
                    Ressources.ListTower[i].Alive = true;
                    Ressources.ListTower[i].Nom = Nom;
                    Ressources.ListTower[i].Position = Position;
                    Ressources.ListTower[i].Effects = Effects;
                    Ressources.ListTower[i].Border = Border;//bordure à enlever(gauche,haut,hauteur,largeur)
                    Ressources.ListTower[i].AnimSpeed = AnimSpeed;
                    Ressources.ListTower[i].AnimEnd = AnimEnd;
                    Ressources.ListTower[i].AnimDeadEnd = AnimDeadEnd;
                    Ressources.ListTower[i].Size = Size;
                    Ressources.ListTower[i].Sprite = Sprite;
                    Ressources.ListTower[i].Type = Type;
                    Ressources.ListTower[i].Mask = new Rectangle((int)Position.X, (int)Position.Y, Size.X, Size.Y);
                    Ressources.ListTower[i].MaskAnim = new Rectangle(0, 0, Size.X, Size.Y);
                    Ressources.ListTower[i].Degat = Degat;
                    Ressources.ListTower[i].ArmePriceBase = ArmePriceBase;
                    Ressources.ListTower[i].ArmePriceModifier = ArmePriceModifier;
                    Ressources.ListTower[i].PriceBase[0] = PriceBase0;
                    Ressources.ListTower[i].PriceBase[1] = PriceBase1;
                    Ressources.ListTower[i].PriceBase[2] = PriceBase2;
                    Ressources.ListTower[i].PriceBase[3] = PriceBase3;
                    Ressources.ListTower[i].PriceBase[4] = PriceBase4;
                    Ressources.ListTower[i].PriceBase[5] = PriceBase5;
                    Ressources.ListTower[i].PriceModifier[0] = PriceModifier0;
                    Ressources.ListTower[i].PriceModifier[1] = PriceModifier1;
                    Ressources.ListTower[i].PriceModifier[2] = PriceModifier2;
                    Ressources.ListTower[i].PriceModifier[3] = PriceModifier3;
                    Ressources.ListTower[i].PriceModifier[4] = PriceModifier4;
                    Ressources.ListTower[i].PriceModifier[5] = PriceModifier5;
                    Ressources.ListTower[i].Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
                    Ressources.ListTower[i].Stats[0] = Stats0;
                    Ressources.ListTower[i].Stats[1] = Stats1;
                    Ressources.ListTower[i].Stats[2] = Stats2;
                    Ressources.ListTower[i].Stats[3] = Stats3;
                    Ressources.ListTower[i].Stats[4] = Stats4;
                    Ressources.ListTower[i].Stats[5] = Stats5;
                    Ressources.ListTower[i].StatsModifier[0] = StatsModifier0;
                    Ressources.ListTower[i].StatsModifier[1] = StatsModifier1;
                    Ressources.ListTower[i].StatsModifier[2] = StatsModifier2;
                    Ressources.ListTower[i].StatsModifier[3] = StatsModifier3;
                    Ressources.ListTower[i].StatsModifier[4] = StatsModifier4;
                    Ressources.ListTower[i].StatsModifier[5] = StatsModifier5;
                    //Armure, Cadence, Energie, Puissance, Resistance, Special;
                    return;
                }
            Tower Stats = new Tower();
            Stats.Nom = Nom;
            Stats.Position = Position;
            Stats.Effects = Effects;
            Stats.Border = Border;//bordure à enlever(gauche,haut,hauteur,largeur)
            Stats.AnimSpeed = AnimSpeed;
            Stats.AnimEnd = AnimEnd;
            Stats.AnimDeadEnd = AnimDeadEnd;
            Stats.Size = Size;
            Stats.Sprite = Sprite;
            Stats.Type = Type;
            Stats.Mask = new Rectangle((int)Position.X, (int)Position.Y, Size.X, Size.Y);
            Stats.MaskAnim = new Rectangle(0, 0, (int)Size.X, (int)Size.Y);
            Stats.Degat = Degat;
            Stats.ArmePriceBase = ArmePriceBase;
            Stats.ArmePriceModifier = ArmePriceModifier;
            Stats.PriceBase[0] = PriceBase0;
            Stats.PriceBase[1] = PriceBase1;
            Stats.PriceBase[2] = PriceBase2;
            Stats.PriceBase[3] = PriceBase3;
            Stats.PriceBase[4] = PriceBase4;
            Stats.PriceBase[5] = PriceBase5;
            Stats.PriceModifier[0] = PriceModifier0;
            Stats.PriceModifier[1] = PriceModifier1;
            Stats.PriceModifier[2] = PriceModifier2;
            Stats.PriceModifier[3] = PriceModifier3;
            Stats.PriceModifier[4] = PriceModifier4;
            Stats.PriceModifier[5] = PriceModifier5;
            Stats.Niveau = new Int16[6] { 1, 1, 1, 1, 1, 1 };
            Stats.Stats[0] = Stats0;
            Stats.Stats[1] = Stats1;
            Stats.Stats[2] = Stats2;
            Stats.Stats[3] = Stats3;
            Stats.Stats[4] = Stats4;
            Stats.Stats[5] = Stats5;
            Stats.StatsModifier[0] = StatsModifier0;
            Stats.StatsModifier[1] = StatsModifier1;
            Stats.StatsModifier[2] = StatsModifier2;
            Stats.StatsModifier[3] = StatsModifier3;
            Stats.StatsModifier[4] = StatsModifier4;
            Stats.StatsModifier[5] = StatsModifier5;
            Ressources.ListTower.Add(Stats);
        }

        public static void PartCreate(bool Flare, PointF Position, PointF Vitesse,
        PointF Gravity, Image Sprite, float AnimSpeed, Int16 AnimEnd, int LifeTime,
        Point Size, int Type)
        {
            for (int i = 0; i < Ressources.ListParticule.Count; i++)
                if (Ressources.ListParticule[i].LifeTime <= 0)
                {
                    Ressources.ListParticule[i].Anim = 0;
                    Ressources.ListParticule[i].Flare = Flare;
                    Ressources.ListParticule[i].LifeTime = LifeTime;
                    Ressources.ListParticule[i].AnimEnd = AnimEnd;
                    Ressources.ListParticule[i].AnimSpeed = AnimSpeed;
                    Ressources.ListParticule[i].Gravity = Gravity;
                    Ressources.ListParticule[i].Position = Position;
                    Ressources.ListParticule[i].Size = Size;
                    Ressources.ListParticule[i].Sprite = Sprite;
                    Ressources.ListParticule[i].Vitesse = Vitesse;
                    Ressources.ListParticule[i].Type = Type;
                    Ressources.ListParticule[i].AnimMask = new Rectangle(0, 0, (int)Size.X, (int)Size.Y);
                    return;
                }
            Particule Stats = new Particule();
            Stats.AnimSpeed = AnimSpeed;
            Stats.AnimEnd = AnimEnd;
            Stats.Flare = Flare;
            Stats.Gravity = Gravity;
            Stats.LifeTime = LifeTime;
            Stats.Position = Position;
            Stats.Size = Size;
            Stats.Sprite = Sprite;
            Stats.Vitesse = Vitesse;
            Stats.Type = Type;
            Stats.AnimMask = new Rectangle(0, 0, (int)Size.X, (int)Size.Y);
            Ressources.ListParticule.Add(Stats);
        }

        public static void MonstreCreate(Image Sprite, PointF Position, float Vie,
        Int16 Degat, Point Size, PointF Vitesse, Rectangle Border, float AnimSpeed,
        Int16 AnimEnd, Int16 AnimDeadEnd, int Type)
        {
            for (int i = 0; i < Ressources.ListMonstre.Count; i++)
                if (!Ressources.ListMonstre[i].Alive)
                {
                    Ressources.ListMonstre[i].Alive = true;
                    Ressources.ListMonstre[i].Anim = 0;
                    Ressources.ListMonstre[i].AnimDeadEnd = AnimDeadEnd;
                    Ressources.ListMonstre[i].AnimEnd = AnimEnd;
                    Ressources.ListMonstre[i].AnimSpeed = AnimSpeed;
                    Ressources.ListMonstre[i].Border = Border;
                    Ressources.ListMonstre[i].Degat = Degat;
                    Ressources.ListMonstre[i].Position = Position;
                    Ressources.ListMonstre[i].Size = Size;
                    Ressources.ListMonstre[i].Sprite = Sprite;
                    Ressources.ListMonstre[i].Vie = Vie;
                    Ressources.ListMonstre[i].Vitesse = Vitesse;
                    Ressources.ListMonstre[i].Type = Type;
                    return;
                }
            Monstre Stats = new Monstre();
            Stats.AnimDeadEnd = AnimDeadEnd;
            Stats.AnimEnd = AnimEnd;
            Stats.AnimSpeed = AnimSpeed;
            Stats.Border = Border;
            Stats.Degat = Degat;
            Stats.Position = Position;
            Stats.Size = Size;
            Stats.Sprite = Sprite;
            Stats.Vie = Vie;
            Stats.Vitesse = Vitesse;
            Stats.Type = Type;
            Ressources.ListMonstre.Add(Stats);
        }

        public static void BalleCreate(Image Sprite, PointF Position, PointF Vitesse,
        float Degat, float Resistance, int Type)
        {
            for (int i = 0; i < Ressources.ListBalle.Count; i++)
                if (!Ressources.ListBalle[i].Alive)
                {
                    Ressources.ListBalle[i].Alive = true;
                    Ressources.ListBalle[i].Degat = Degat;
                    Ressources.ListBalle[i].Position = Position;
                    Ressources.ListBalle[i].Resistance = Resistance;
                    Ressources.ListBalle[i].Sprite = Sprite;
                    Ressources.ListBalle[i].Type = Type;
                    Ressources.ListBalle[i].Vitesse = Vitesse;
                    return;
                }
            Balle Stats = new Balle();
            Stats.Degat = Degat;
            Stats.Position = Position;
            Stats.Resistance = Resistance;
            Stats.Sprite = Sprite;
            Stats.Type = Type;
            Stats.Vitesse = Vitesse;
            Ressources.ListBalle.Add(Stats);
        }
        void CreateTower()
        {
            switch (Group)
            {
                case 0:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    TowerCreate("Bunker", 0, TowerPlace.Location, Effects,
                                        new Rectangle(0, 0, 0, 0), 0, 0, 0, new Point(30, 30), Ressources.SprTower[0, 0, Convert.ToInt16(Effects)], 0,
                                        100, 150, 20, 25, 25, 25, 25, 25, 50, 50, 50, 50, 50, 50,
                                        10, 30, 4, 6, 1, 0, 2, -2.5f, -0.3f, 1, 1.5f, 1);
                                    break;
                                }
                            case 1:
                                {
                                    TowerCreate("Arbre d'attaque", 1, TowerPlace.Location, Effects,
                                        new Rectangle(0, 0, 0, 0), 0, 0, 0, new Point(30, 30), Ressources.SprTower[0, 1, Convert.ToInt16(Effects)], 0,
                                        100, 150, 25, 25, 25, 25, 25, 25, 50, 50, 50, 50, 50, 50,
                                        8, 40, 2, 4, 1, 0, 1, -2, -0.2f, 0.75f, 1, 1);
                                    break;
                                }
                        }
                        break;
                    }
                case 2:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    TowerCreate("Roue humaine", 2, TowerPlace.Location, Effects,
                                        new Rectangle(0, 0, 0, 0), 0.2f, 3, 3, new Point(60, 60), Ressources.SprTower[2, 0, Convert.ToInt16(Effects)], 1,
                                        200, 175, 75, 0, 150, 0, 0, 0, 100, -1, 125, -1, -1, -1,
                                        5, 0, -0.5f, 0, 0, 0, 1, 0, -0.15f, 0, 0, 0);
                                    break;
                                }
                            case 1:
                                {
                                    TowerCreate("Echafaud", 3, TowerPlace.Location, Effects,
                                        new Rectangle(0, 0, 0, 0), 0, 0, 0, new Point(30, 30), Ressources.SprTower[2, 1, Convert.ToInt16(Effects)], 0,
                                        0, 0, 0, 0, 0, 0, 0, 0, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0,
                                        0, 0, 0, 0, 0, 0);
                                    break;
                                }
                        }
                        break;
                    }
            }
        }
        bool CanBuildTower(bool Buy)
        {
            switch (Group)
            {
                case 0:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    if (Argent < 100)
                                        return false;
                                    if (Buy)
                                        Argent -= 100;
                                    break;
                                }
                            case 1:
                                {
                                    if (Argent < 100)
                                        return false;
                                    if (Buy)
                                        Argent -= 100;
                                    break;
                                }
                        }
                        break;
                    }
                case 2:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    if (Argent < 200)
                                        return false;
                                    if (Buy)
                                        Argent -= 200;
                                    break;
                                }
                            case 1:
                                {
                                    if (Argent < 50)
                                        return false;
                                    if (Buy)
                                        Argent -= 50;
                                    break;
                                }
                        }
                        break;
                    }
            }
            return true;
        }
        void CreateMonstre(Int16 Type)
        {
            switch (Type)
            {
                case 0:
                    {
                        if (Random.Next(2) == 0)
                            MonstreCreate(Ressources.SprMonstre[0, 0], new PointF(-30, 690), 10 + MonstreLife[Type], 1, new Point(30, 30), new PointF(3, 0), new Rectangle(0, 0, 30, 30), 0.2f, 2, 6, 0);
                        else
                            MonstreCreate(Ressources.SprMonstre[0, 1], new PointF(1024, 690), 10 + MonstreLife[Type], 1, new Point(30, 30), new PointF(-3, 0), new Rectangle(0, 0, 30, 30), 0.2f, 2, 6, 0);
                        break;
                    }
                case 1:
                    {
                        if (Random.Next(2) == 0)
                            MonstreCreate(Ressources.SprMonstre[1, 0], new PointF(-30, 656), 15 + MonstreLife[Type], 3, new Point(88, 64), new PointF(2, 0), new Rectangle(25, 4, 30, 60), 0.3f, 3, 9, 1);
                        else
                            MonstreCreate(Ressources.SprMonstre[1, 1], new PointF(1024, 656), 15 + MonstreLife[Type], 3, new Point(88, 64), new PointF(-2, 0), new Rectangle(25, 4, 30, 60), 0.3f, 3, 9, 1);
                        break;
                    }
                case 2:
                    {
                        if (Random.Next(2) == 0)
                            MonstreCreate(Ressources.SprMonstre[2, 0], new PointF(-30, 641), 3 + MonstreLife[Type], 1, new Point(70, 60), new PointF(5, 0), new Rectangle(32, 15, 30, 30), 0.2f, 3, 8, 2);
                        else
                            MonstreCreate(Ressources.SprMonstre[2, 1], new PointF(1024, 641), 3 + MonstreLife[Type], 1, new Point(70, 60), new PointF(-5, 0), new Rectangle(32, 15, 30, 30), 0.2f, 3, 8, 2);
                        break;
                    }
            }
        }
        public static void AddWave(int[] Monster, int[] MonsterLife, int[] Delay, int[] StartUp)
        {
            for (int i = 0; i < 3; i++)
            {
                Form1.MonsterSpawn[i] += Monster[i];//Nombre de monstre
                Form1.MonstreLife[i] = MonsterLife[i];//HP supplémentaire
            }
            Form1.TimerBase = Delay;//Délai d'apparition
            Form1.Timer = StartUp;//Temps avant première apparition
        }
        public static void WaveSelect()
        {
            Wave++;
            switch (Wave)
            {
                case 1:
                    {
                        Form1.AddWave(new int[] { 10, 0, 0 }, new int[] { 0, 0, 0 }, new int[] { 100, 0, 0 }, new int[] { 100, 0, 0 });
                        break;
                    }
                case 2:
                    {
                        Form1.AddWave(new int[] { 12, 2, 0 }, new int[] { 2, 0, 0 }, new int[] { 100, 120, 0 }, new int[] { 0, 150, 0 });
                        break;
                    }
                case 3:
                    {
                        Form1.AddWave(new int[] { 15, 3, 2 }, new int[] { 6, 3, 0 }, new int[] { 100, 120, 140 }, new int[] { 0, 150, 130 });
                        break;
                    }
                case 4:
                    {
                        Form1.AddWave(new int[] { 18, 4, 4 }, new int[] { 10, 8, 6 }, new int[] { 100, 120, 140 }, new int[] { 0, 100, 130 });
                        break;
                    }
                case 5:
                    {
                        Form1.AddWave(new int[] { 23, 5, 10 }, new int[] { 20, 15, 10 }, new int[] { 90, 110, 135 }, new int[] { 0, 100, 100 });
                        break;
                    }
                case 6:
                    {
                        Form1.AddWave(new int[] { 28, 7, 14 }, new int[] { 30, 23, 18 }, new int[] { 80, 110, 135 }, new int[] { 0, 50, 90 });
                        break;
                    }
                case 7:
                    {
                        Form1.AddWave(new int[] { 35, 10, 19 }, new int[] { 50, 30, 27 }, new int[] { 70, 100, 120 }, new int[] { 0, 40, 80 });
                        break;
                    }
            }
        }
        void LevelUp()
        {
            switch (Niveau)
            {
                case 0:
                    {
                        MaxEnergie += 10;
                        MaxVie += 5;
                        MaxExp += 500;
                        break;
                    }
                case 1:
                    {
                        MaxEnergie += 10;
                        MaxVie += 5;
                        MaxExp += 500;
                        break;
                    }
                case 2:
                    {
                        MaxEnergie += 15;
                        MaxVie += 10;
                        MaxExp += 750;
                        break;
                    }
                case 3:
                    {
                        MaxEnergie += 15;
                        MaxVie += 10;
                        MaxExp += 1000;
                        break;
                    }
                case 4:
                    {
                        MaxEnergie += 30;
                        MaxVie += 20;
                        MaxExp += 1000;
                        break;
                    }
            }
            Niveau++;
            Exp = 0;
            Energie = MaxEnergie;
            Vie = MaxVie;
        }
        void Draw()
        {
            GraphicDevice.Graphics.Clear(Color.CornflowerBlue);
            for (Int16 i = 0; i < 20; i++)
                GraphicDevice.Graphics.DrawImage(SprNuage[ListNuage[i].Sprite], ListNuage[i].Position);
            GraphicDevice.Graphics.DrawImage(SprSol, 0, 715);
            GraphicDevice.Graphics.DrawImage(SprCBNA, 406, 578);
            GraphicDevice.Graphics.DrawImage(SprPowerBar[0], 445, 727);
            GraphicDevice.Graphics.DrawImage(SprPowerBar[1], new Rectangle(446, 728, Convert.ToInt32(138 / (double)MaxVie * Vie), 8));
            GraphicDevice.Graphics.DrawImage(SprPowerBar[0], 445, 737);
            GraphicDevice.Graphics.DrawImage(SprPowerBar[2], new Rectangle(446, 738, Convert.ToInt32(138 / (double)MaxEnergie * Energie), 8));
            GraphicDevice.Graphics.DrawImage(SprPowerBar[0], 445, 747);
            GraphicDevice.Graphics.DrawImage(SprPowerBar[3], new Rectangle(446, 748, Convert.ToInt32(138 / (double)MaxExp * Exp), 8));
            foreach (Particule Particule in Ressources.ListParticule)
                if (Particule.LifeTime > 0)
                    GraphicDevice.Graphics.DrawImage(Particule.Sprite, new Rectangle((int)Particule.Position.X, (int)Particule.Position.Y, Particule.Size.X, Particule.Size.Y), Particule.AnimMask, GraphicsUnit.Pixel);
            foreach (Monstre Monstre in Ressources.ListMonstre)
                if (Monstre.Alive)
                    GraphicDevice.Graphics.DrawImage(Monstre.Sprite, new Rectangle((int)Monstre.Position.X, (int)Monstre.Position.Y, Monstre.Size.X, Monstre.Size.Y), Monstre.MaskAnim, GraphicsUnit.Pixel);
            foreach (Balle Balle in Ressources.ListBalle)
                if (Balle.Alive)
                    GraphicDevice.Graphics.DrawImage(Balle.Sprite, Balle.Position);
            foreach (Tower Tower in Ressources.ListTower)
                if (Tower.Alive)
                    GraphicDevice.Graphics.DrawImage(Tower.Sprite, new Rectangle((int)Tower.Position.X, (int)Tower.Position.Y, Tower.Size.X, Tower.Size.Y), Tower.MaskAnim, GraphicsUnit.Pixel);
            if (!IsSelected)
                GraphicDevice.Graphics.DrawImage(SprSelector[0], TowerPlace);
            if (Selectector > 0 && !IsSelected)
            {
                GraphicDevice.Graphics.DrawImage(SprTowerSelect, 0, 768 - Selectector);
                GraphicDevice.Graphics.DrawString("Tour de sol", Kootenay, TextAqua, 20, 772 - Selectector);
                GraphicDevice.Graphics.DrawString("Tour flotante", Kootenay, TextAqua, 520, 772 - Selectector);
                GraphicDevice.Graphics.DrawString("Utilitaire", Kootenay, TextAqua, 20, 836 - Selectector);
                GraphicDevice.Graphics.DrawString("Protection", Kootenay, TextAqua, 520, 836 - Selectector);
                switch (Group)
                {
                    case 0:
                        {
                            GraphicDevice.Graphics.DrawImage(SprTowerSelector, 25 + (50 * Select), 793 - Selectector);
                            break;
                        }
                    case 2:
                        {
                            GraphicDevice.Graphics.DrawImage(SprTowerSelector, 25 + (50 * Select), 857 - Selectector);
                            break;
                        }
                }
                //Tours
                for (Int16 i = 0; i < GroupSize[0]; i++)
                {
                    GraphicDevice.Graphics.DrawImage(SprShopPreview[0, i], 30 + (50 * i), 798 - Selectector);
                }
                //Utilitaire
                for (Int16 i = 0; i < GroupSize[2]; i++)
                {
                    GraphicDevice.Graphics.DrawImage(SprShopPreview[2, i], 30 + (50 * i), 862 - Selectector);
                }
                if (SelectHelp >= 160)
                    DrawHelpMenu();
            }
            GraphicDevice.Graphics.DrawString(Argent.ToString() + "$", Kootenay, TextAqua, 490, 590);
            if (Upgrading)
                DrawUpgradeMenu();
            if (IsSelected)
                if (CanPlace)
                {
                    GraphicDevice.Graphics.DrawImage(Ressources.SprTower[Group, Select, Convert.ToInt16(Effects)], TowerPlace, new Rectangle(0, 0, TowerPlace.Width, TowerPlace.Height), GraphicsUnit.Pixel);
                    GraphicDevice.Graphics.DrawImage(SprSelector[2], TowerPlace);
                }
                else
                {
                    GraphicDevice.Graphics.DrawImage(Ressources.SprTower[Group, Select, Convert.ToInt16(Effects)], TowerPlace, new Rectangle(0, 0, TowerPlace.Width, TowerPlace.Height), GraphicsUnit.Pixel);
                    GraphicDevice.Graphics.DrawImage(SprSelector[1], TowerPlace);
                }
            GraphicDevice.Graphics.DrawString("Vague: " + Wave, Kootenay, TextBlack, new PointF(10, 5));
            GraphicDevice.Render();
        }
        void DrawHelpMenu()
        {
            GraphicDevice.Graphics.DrawImage(SprHelpMenu, 0, 543);
            GraphicDevice.Graphics.DrawString("Argent diponible:", Kootenay, TextBlack, new PointF(370, 590));
            switch (Group)
            {
                case 0:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    GraphicDevice.Graphics.DrawString("Bunker", Kootenay, TextBlack, new PointF(20, 550));
                                    GraphicDevice.Graphics.DrawString("Description: Tour de base puissante avec un bonne armure.", Kootenay, TextBlack, new PointF(100, 550));
                                    GraphicDevice.Graphics.DrawString("Armure: 10", Kootenay, TextBlack, new PointF(20, 570));
                                    GraphicDevice.Graphics.DrawString("Cadence: 30", Kootenay, TextBlack, new PointF(187, 570));
                                    GraphicDevice.Graphics.DrawString("Mana requis: 4", Kootenay, TextBlack, new PointF(354, 570));
                                    GraphicDevice.Graphics.DrawString("Puissance: 6", Kootenay, TextBlack, new PointF(521, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort balle: 1", Kootenay, TextBlack, new PointF(688, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort unique: 0", Kootenay, TextBlack, new PointF(855, 570));
                                    GraphicDevice.Graphics.DrawString("Prix: 100$", Kootenay, TextBlack, new PointF(20, 590));
                                    break;
                                }
                            case 1:
                                {
                                    GraphicDevice.Graphics.DrawString("Arbre d'attaque", Kootenay, TextBlack, new PointF(20, 550));
                                    GraphicDevice.Graphics.DrawString("Description: Tour de base naturelle pouvant s'empiller.", Kootenay, TextBlack, new PointF(150, 550));
                                    GraphicDevice.Graphics.DrawString("Armure: 8", Kootenay, TextBlack, new PointF(20, 570));
                                    GraphicDevice.Graphics.DrawString("Cadence: 40", Kootenay, TextBlack, new PointF(187, 570));
                                    GraphicDevice.Graphics.DrawString("Mana requis: 2", Kootenay, TextBlack, new PointF(354, 570));
                                    GraphicDevice.Graphics.DrawString("Puissance: 4", Kootenay, TextBlack, new PointF(521, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort balle: 1", Kootenay, TextBlack, new PointF(688, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort unique: 0", Kootenay, TextBlack, new PointF(855, 570));
                                    GraphicDevice.Graphics.DrawString("Prix: 100$", Kootenay, TextBlack, new PointF(20, 590));
                                    break;
                                }
                        }
                        break;
                    }
                case 2:
                    {
                        switch (Select)
                        {
                            case 0:
                                {
                                    GraphicDevice.Graphics.DrawString("Roue humaine", Kootenay, TextBlack, new PointF(20, 550));
                                    GraphicDevice.Graphics.DrawString("Description: Roue immense utilisant la peur des humains pour produire du mana.", Kootenay, TextBlack, new PointF(150, 550));
                                    GraphicDevice.Graphics.DrawString("Armure: 5", Kootenay, TextBlack, new PointF(20, 570));
                                    GraphicDevice.Graphics.DrawString("Cadence: 0", Kootenay, TextBlack, new PointF(187, 570));
                                    GraphicDevice.Graphics.DrawString("Mana requis: -2", Kootenay, TextBlack, new PointF(354, 570));
                                    GraphicDevice.Graphics.DrawString("Puissance: 0", Kootenay, TextBlack, new PointF(521, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort balle: 0", Kootenay, TextBlack, new PointF(688, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort unique: 0", Kootenay, TextBlack, new PointF(855, 570));
                                    GraphicDevice.Graphics.DrawString("Prix: 200$", Kootenay, TextBlack, new PointF(20, 590));
                                    break;
                                }
                            case 1:
                                {
                                    GraphicDevice.Graphics.DrawString("Echafaud", Kootenay, TextBlack, new PointF(20, 550));
                                    GraphicDevice.Graphics.DrawString("Description: Echafaud permettant d'empiler les tours.", Kootenay, TextBlack, new PointF(100, 550));
                                    GraphicDevice.Graphics.DrawString("Armure: 10", Kootenay, TextBlack, new PointF(20, 570));
                                    GraphicDevice.Graphics.DrawString("Cadence: 0", Kootenay, TextBlack, new PointF(187, 570));
                                    GraphicDevice.Graphics.DrawString("Mana requis: 0", Kootenay, TextBlack, new PointF(354, 570));
                                    GraphicDevice.Graphics.DrawString("Puissance: 0", Kootenay, TextBlack, new PointF(521, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort balle: 0", Kootenay, TextBlack, new PointF(688, 570));
                                    GraphicDevice.Graphics.DrawString("Renfort unique: 0", Kootenay, TextBlack, new PointF(855, 570));
                                    GraphicDevice.Graphics.DrawString("Prix: 50$", Kootenay, TextBlack, new PointF(20, 590));
                                    break;
                                }
                        }
                        break;
                    }
            }
        }
        void DrawUpgradeMenu()
        {
            if (UpgradeMenu.X > 602)
                UpgradeMenu.X -= 430;
            if (UpgradeMenu.Y > 630)
                UpgradeMenu.Y = 630;
            GraphicDevice.Graphics.DrawImage(SprUpgradeMenu, UpgradeMenu.X + 30, UpgradeMenu.Y - 100);
            if (IsUpgradeHelp)
                DrawUpgradeHelpMenu();
            for (Int16 i = 0; i < 7; i++)
            {
                GraphicDevice.Graphics.DrawImage(SprUpgradeButtonUp, UpgradeMenu.X + 303, UpgradeMenu.Y - 94 + (i * 28));
                GraphicDevice.Graphics.DrawImage(SprUpgradeHelpUp, UpgradeMenu.X + 390, UpgradeMenu.Y - 96 + (i * 28));
                if (UpgradeSelect == i)
                    if (IsUpgrade)
                        GraphicDevice.Graphics.DrawImage(SprUpgradeButtonDown, UpgradeMenu.X + 303, UpgradeMenu.Y - 94 + (i * 28));
                    else
                        GraphicDevice.Graphics.DrawImage(SprUpgradeHelpDown, UpgradeMenu.X + 390, UpgradeMenu.Y - 96 + (i * 28));
                GraphicDevice.Graphics.DrawString("Acheter", Kootenay, TextBlack, new PointF(UpgradeMenu.X + 314, UpgradeMenu.Y - 91 + (i * 28)));
            }
            //Arme
            GraphicDevice.Graphics.DrawString(TowerSelected.Nom, Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y - 91));
            GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.ArmePriceBase + TowerSelected.ArmeLvL * TowerSelected.ArmePriceModifier) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y - 91));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y - 91));
            GraphicDevice.Graphics.DrawString(TowerSelected.ArmeLvL.ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y - 91));
            //Armure
            GraphicDevice.Graphics.DrawString("Armure:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y - 61));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[0].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 96, UpgradeMenu.Y - 61));
            if (TowerSelected.PriceModifier[0] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[0] + (TowerSelected.Niveau[0] / 3 + 1) * TowerSelected.Niveau[0] * TowerSelected.PriceModifier[0]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y - 61));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y - 61));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[0].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y - 61));
            //Cadence
            GraphicDevice.Graphics.DrawString("Cadence:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y - 33));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[1].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 110, UpgradeMenu.Y - 33));
            if (TowerSelected.PriceModifier[1] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[1] + (TowerSelected.Niveau[1] / 3 + 1) * TowerSelected.Niveau[1] * TowerSelected.PriceModifier[1]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y - 33));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y - 33));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[1].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y - 33));
            //Énergie
            GraphicDevice.Graphics.DrawString("Mana requis:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y - 5));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[2].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 132, UpgradeMenu.Y - 5));
            if (TowerSelected.PriceModifier[2] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[2] + (TowerSelected.Niveau[2] / 3 + 1) * TowerSelected.Niveau[2] * TowerSelected.PriceModifier[2]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y - 5));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y - 5));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[2].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y - 5));
            //Puissance
            GraphicDevice.Graphics.DrawString("Puissance:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 25));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[3].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 118, UpgradeMenu.Y + 25));
            if (TowerSelected.PriceModifier[3] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[3] + (TowerSelected.Niveau[3] / 3 + 1) * TowerSelected.Niveau[3] * TowerSelected.PriceModifier[3]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y + 25));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y + 25));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[3].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y + 25));
            //Résistance
            GraphicDevice.Graphics.DrawString("Renfort balle:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 53));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[4].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 134, UpgradeMenu.Y + 53));
            if (TowerSelected.PriceModifier[4] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[4] + (TowerSelected.Niveau[4] / 3 + 1) * TowerSelected.Niveau[4] * TowerSelected.PriceModifier[4]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y + 53));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y + 53));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[4].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y + 53));
            //Spécial
            GraphicDevice.Graphics.DrawString("Renfort unique:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 81));
            GraphicDevice.Graphics.DrawString(TowerSelected.Stats[5].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 152, UpgradeMenu.Y + 81));
            if (TowerSelected.PriceModifier[5] >= 0)
                GraphicDevice.Graphics.DrawString(Convert.ToString(TowerSelected.PriceBase[5] + (TowerSelected.Niveau[5] / 3 + 1) * TowerSelected.Niveau[5] * TowerSelected.PriceModifier[5]) + "$", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 200, UpgradeMenu.Y + 81));
            GraphicDevice.Graphics.DrawString("Niveau:", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 240, UpgradeMenu.Y + 81));
            GraphicDevice.Graphics.DrawString(TowerSelected.Niveau[5].ToString(), Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 290, UpgradeMenu.Y + 81));
        }
        void DrawUpgradeHelpMenu()
        {
            GraphicDevice.Graphics.DrawImage(SprUpgradeHelpMenu, UpgradeMenu.X + 30, UpgradeMenu.Y + 93);
            switch (UpgradeSelect)
            {
                case 0:
                    {
                        GraphicDevice.Graphics.DrawString("L'augmentation du niveau de l'arme permet d'acheter\nde nouveaux niveaux pour vos options de batiment.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 1:
                    {
                        GraphicDevice.Graphics.DrawString("Augmente la protection dont le batiment dispose\ncontre les vagues d'ennemies.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 2:
                    {
                        GraphicDevice.Graphics.DrawString("Diminue le temps de recharge entre deux tirs.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 3:
                    {
                        GraphicDevice.Graphics.DrawString("Diminue le mana utilser par le batiment pour s'utiliser.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 4:
                    {
                        GraphicDevice.Graphics.DrawString("Augmente la puissance de feu dont chaque balle\ndispose.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 5:
                    {
                        GraphicDevice.Graphics.DrawString("Augmente la protection dont les tirs disposent avant\nde disparaitre.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
                case 6:
                    {
                        GraphicDevice.Graphics.DrawString("Augmente la puissance du renfort unique que chaque\ntype de batiment utilise.", Kootenay, TextForestGreen, new PointF(UpgradeMenu.X + 40, UpgradeMenu.Y + 100));
                        break;
                    }
            }
        }
    }
}